import 'dart:async';

enum Mode { SYNC, ASYNC }

/// Builds a factory shared part and so makes class injectable
class Injectable {
  final Mode mode;
  const Injectable({this.mode = Mode.SYNC});
}

/// Same as Component(), but the class instance is cached
class Singleton {
  final Mode mode;
  const Singleton({this.mode = Mode.SYNC});
}

/// Creates a provier. should implement the ProviderBase<T> abstract class
class Provider {
  final Mode mode;
  const Provider({this.mode = Mode.SYNC});
}

abstract class ProviderBase<T> {
  FutureOr<T> provide();
}

class ProvidedBy {
  final Type provider;
  const ProvidedBy(this.provider);
}
